<?php
/*
Plugin Name: WenderHost Subpages widget
Description: Adds a subpages menu to your sidebar if subpages are present.
Author: Michael Wender
Version: 1.0.1
Plugin URI: http://wenderhost.com/downloads/wordpress-plugins/subpages-widget/
Author URI: http://michaelwender.com
*/
function widget_wenderhost_subpages_init() {
	// Check for the required plugin functions. This will prevent fatal
	// errors occurring when you deactivate the dynamic-sidebar plugin.
	if ( !function_exists('register_sidebar_widget') )
		return;	
	register_deactivation_hook( __FILE__ , 'delete_widget_wenderhost_subpages_options'); //removing the options from the option table
	
	
	function widget_wenderhost_subpages($args){
		extract($args);
		$options = get_option('widget_wenderhost_subpages');
		$top_id = widget_wenderhost_subpages_top_parent_page();
		$top_page = get_post($top_id);
		$top_title = $top_page->post_title; 
		$top_permalink = get_permalink($top_page->ID);
		(!empty($options['sort_column']))? $sort_column = $options['sort_column'] : $sort_column = 'menu_order';
		$sub_pages = wp_list_pages('sort_column=' .$sort_column. '&title_li=&echo=0&child_of=' .$top_id);
		if ($sub_pages <> "" ){
			echo $before_widget;
			echo $before_title . '<span id="subpages-title"><a href="' .$top_permalink. '">' .$top_title. '</a> &raquo;</span>' . $after_title;
		?>
			<ul id="subpages"><?php echo $sub_pages; ?></ul>
		<?php 
			echo $after_widget;
			
			if(is_array($options)){
				if($options['divider'] == true) echo '<li class="subpages-divider" style="' .$options['divider_style']. '">&nbsp;</li>' . "\n";
			}
		}
	}

	function widget_wenderhost_subpages_top_parent_page(){
		global $post;
		$widget_wenderhost_subpages_post = $post;
		$topparentpageid = $widget_wenderhost_subpages_post->ID;
		$widget_wenderhost_subpages_post_parent_id = $widget_wenderhost_subpages_post->post_parent;
		while ($widget_wenderhost_subpages_post_parent_id) {
			$widget_wenderhost_subpages_post = &get_post($widget_wenderhost_subpages_post_parent_id);
			$topparentpageid = $widget_wenderhost_subpages_post->ID;
			$widget_wenderhost_subpages_post_parent_id = $widget_wenderhost_subpages_post->post_parent;
		}
		return $topparentpageid;
	}
	
	function widget_wenderhost_subpages_options(){
		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_wenderhost_subpages');
		if ( !is_array($options) )
			$options = array('divider'=>'', 'divider_style'=> '');
		if ( $_POST['widget_wenderhost_subpages-submit'] ) {

			// Remember to sanitize and format use input appropriately.
			$options['sort_column'] = $_POST['widget_wenderhost_subpages-sort_column'];
			$options['divider'] = strip_tags(stripslashes($_POST['widget_wenderhost_subpages-divider']));
			$options['divider_style'] = strip_tags(stripslashes($_POST['widget_wenderhost_subpages-divider_style']));
			update_option('widget_wenderhost_subpages', $options);
		}

		// Be sure you format your options to be valid HTML attributes.
		if(!empty($options['sort_column'])){
			if($options['sort_column'] == 'post_title'){
				$menu_order_checked = '';
				$post_title_checked = ' checked="checked"';
			} else {
				$menu_order_checked = ' checked="checked"';
				$post_title_checked = '';			
			}
		} else {
			$menu_order_checked = ' checked="checked"';
		}
		if($options['divider'] == 1) $checked = ' checked="checked"';
		$divider_style = htmlspecialchars($options['divider_style'], ENT_QUOTES);
		
		echo '<p style="text-align:left;"><label for="widget_wenderhost_subpages-sort_column">' . __('Sort subpages by:'). "\n";
		echo '<br />Menu Order: <input id="widget_wenderhost_subpages-sort_column1" name="widget_wenderhost_subpages-sort_column" type="radio" value="menu_order"' .$menu_order_checked. '/>' . "\n"; 
		echo '<br />Page Title: <input id="widget_wenderhost_subpages-sort_column2" name="widget_wenderhost_subpages-sort_column" type="radio" value="post_title"' .$post_title_checked. '/></label></p>' . "\n";
		echo '<p style="text-align:left;"><label for="widget_wenderhost_subpages-divider">' . __('Use divider:') . ' <input id="widget_wenderhost_subpages-divider" name="widget_wenderhost_subpages-divider" type="checkbox" value="1"' .$checked. '/></label><br />(Adds a visual divider beneath the subpages sidebox.)</p>';
		echo '<p style="text-align:left;"><label for="widget_wenderhost_subpages-divider_style">' . __('Divider CSS Styles:', 'widgets') . ' <input style="width: 350px;" id="widget_wenderhost_subpages-divider_style" name="widget_wenderhost_subpages-divider_style" type="text" value="'.$divider_style.'" /></label></p>';
		echo '<input type="hidden" id="widget_wenderhost_subpages-submit" name="widget_wenderhost_subpages-submit" value="1" />';		
	}
	
	function delete_widget_wenderhost_subpages_options(){
		/* hooks submitted upon deactivation*/
		delete_option('widget_wenderhost_subpages');
	}
	
	// This registers the widget so it appears with the other available
	// widgets and can be dragged and dropped into any active sidebars.
	register_sidebar_widget(array('WH-Subpages', 'widgets'), 'widget_wenderhost_subpages');
	register_widget_control(array('WH-Subpages', 'widgets'), 'widget_wenderhost_subpages_options', 400, 200);				

}
add_action('widgets_init', 'widget_wenderhost_subpages_init');
?>